<?php
$m = 'Vpn';
$berogui_path = '/usr/local/www/berogui';

/* [CHECKING SESSION] */
$newTarget = "/app/berogui/index.php?m=$m";
include("$berogui_path/includes/session.php");
unset($newTarget);

/* [CHECKING GET] */
unset($_GET);

/* [CHECKING POST] */
unset($_POST['submit']);

$exec_ajax = 1;
$invalid = array();

$list_data = array(
	'ipaddr' 	=> 'ip4',
	'ipnetmask' 	=> 'ip4',
	'iprange' 	=> 'ip4',
	'port'		=> 'int-range',
	'protocol'	=> 'select',
);

$options_data = array(
	'port'		=> array('min' => 1094, 'max' => 65535),
	'protocol'	=> array('UDP', 'TCP'),
);

require_once("$berogui_path/includes/Helper/Helper.php");
$id = Helper::sanitizePost($_POST['idkey'], 'int>=0', $exec_ajax, $invalid);
$data = Helper::sanitizePost($_POST['data'], $list_data, $exec_ajax, $invalid, $options_data);
unset($_POST);

/* [EXECUTING AJAX] */
if (!$exec_ajax) {
	echo "<script>window.location='../../index.php?m=$m&error=1&request={$invalid['request']}&checkor={$invalid['checkor']}&key={$invalid['key']}'</script>";
	exit(1);
}

// update VPN settings using nodejs server
require_once("$berogui_path/includes/sbcApi.php");
$sbc_api = new sbcApi();
if ($ret = $sbc_api->updateVpnServer($id, $data)) {
	$error = json_decode($ret, true);
	echo "<script>window.location='../../index.php?m=$m&error=2&reason={$error['error'][0]['message']}'</script>";
	exit(1);
}

// update database
require_once("$berogui_path/misc/database.php");
$ba = new beroAri();
$ba->updateTable('sbc_vpns', $id, $data);

// update main vpn (LAN)
if ($id == '0') {
	require_once('/usr/fallback/beroConf.php');
	$bc = new beroConf('root');
	$update = array(
		'lan-ipaddr' 	=> Helper::getNetworkIpAddr('tun0'),
		'lan-netmask'	=> Helper::getNetworkMask('tun0'),
	);
	foreach ($update as $key => $value) {
		$bc->set('root', $key, $value);
	}
}

// yellow activate and redirect
Helper::activate(1);
if ($ba->is_error()) {
        echo "<script>alert('". $ba->error() . "');</script>";
}
else {
        echo "<script>window.location='../../index.php?m=$m'</script>";
}

exit(0);
?>
